{$APPTYPE CONSOLE}
uses
  Math, Types;

type
  TSegment = record
    x, y, dx, dy, len: Integer;
    r: TRect;
  end;

  TWindow = record
    x, y, count: Integer;
  end;

var
  a: array of TSegment;
  w: array of TWindow;
  S: integer;

procedure Sort2(var a, b: Integer);
var
  t: Integer;
begin
  if a > b then begin t := a; a := b; b := t; end;
end;

function BinarySearch(const win: TWindow): Integer;
var
  lo, hi, mid: Integer;
  rwin, dummy: TRect;
begin
  lo := 0; hi := High(a);
  rwin := Rect(win.x - 1, win.y - S - 1, win.x + S + 1, win.y + 1);
  while lo + 1 < hi do begin
    mid := (lo + hi) div 2;
    with a[mid] do begin
      Sort2(r.Left, r.Right);
      Sort2(r.Top, r.Bottom);
      if IntersectRect(dummy, r, rwin) then hi := mid - 1 else lo := mid;
    end;
  end;
  Result := lo;
end;


function IntersectLen(b1, e1, b2, e2: Integer): Integer;
var
  t: Integer;
begin
  if b1 > e1 then begin t := b1; b1 := e1; e1 := t; end;
  b1 := Max(b1, b2); e1 := Min(e1, e2);
  Result := Max(e1 - b1 + 1, 0);
end;

procedure Draw(const seg: TSegment; var win: TWindow; countLast: Boolean);
var
  t: Integer;
begin
  t := seg.len - 2 + Ord(countLast);
  if seg.dy = 0 then begin
    if InRange(seg.y, win.y - S + 1, win.y) then begin
      t := seg.x + seg.dx * t;
      Inc(win.count, IntersectLen(seg.x, t, win.x, win.x + S - 1));
    end;
  end
  else begin
    if InRange(seg.x, win.x, win.x + S - 1) then begin
      t := seg.y + seg.dy * t;
      Inc(win.count, IntersectLen(seg.y, t, win.y - S + 1, win.y));
    end;
  end;
end;

var
  f: TextFile;
  i, j, m, t, x, y, dx, dy, N, K: Integer;
  r: TRect;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N, K, S);
  SetLength(a, N);
  SetLength(w, K);
  for i := 0 to N - 1 do Read(f, a[i].len);
  for i := 0 to K - 1 do Read(f, w[i].x, w[i].y);
  CloseFile(f);

  x := 0; y := 0; dx := 1; dy := 0;
  r := Rect(0, 0, 0, 0);
  for i := 0 to High(a) do begin
    a[i].x := x;
    a[i].y := y;
    UnionRect(a[i].r, r, Rect(x, y, x + 1, y + 1));
    r := a[i].r;
    Inc(x, dx * (a[i].len - 1));
    Inc(y, dy * (a[i].len - 1));
    a[i].dx := dx;
    a[i].dy := dy;
    t := dy;
    dy := -dx;
    dx := t;
  end;
  for j := 0 to High(w) do begin
    t := BinarySearch(w[j]);
    m := Min(High(a), t + 4 * S + 2);
    Writeln(t);
    with a[t] do
      Writeln(r.Left, ' ', r.Top, ' ', r.Right, ' ', r.Bottom);
    for i := Max(t - 4 * S, 0) to m do
      Draw(a[i], w[j], i = m);
  end;
  AssignFile(f, 'output.txt'); Rewrite(f);
  for i := 0 to High(w) do
    Write(f, w[i].count, ' ');
  CloseFile(f);
end.