{$APPTYPE CONSOLE}
uses
  Math;

type
  TSegment = record
    x, y, dx, dy, len: Integer;
  end;

  TWindow = record
    x, y, count: Integer;
  end;

var
  a: array of TSegment;
  w: array of TWindow;
  S: integer;

function IntersectLen(b1, e1, b2, e2: Integer): Integer;
var
  t: Integer;
begin
  if b1 > e1 then begin t := b1; b1 := e1; e1 := t; end;
  b1 := Max(b1, b2); e1 := Min(e1, e2);
  Result := Max(e1 - b1 + 1, 0);
end;

procedure Draw(const seg: TSegment; var win: TWindow; countLast: Boolean);
var
  t: Integer;
begin
  t := seg.len - 2 + Ord(countLast);
  if seg.dy = 0 then begin
    if InRange(seg.y, win.y - S + 1, win.y) then begin
      t := seg.x + seg.dx * t;
      Inc(win.count, IntersectLen(seg.x, t, win.x, win.x + S - 1));
    end;
  end
  else begin
    if InRange(seg.x, win.x, win.x + S - 1) then begin
      t := seg.y + seg.dy * t;
      Inc(win.count, IntersectLen(seg.y, t, win.y - S + 1, win.y));
    end;
  end;
end;

var
  f: TextFile;
  i, j, t, x, y, dx, dy, N, K: Integer;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N, K, S);
  SetLength(a, N);
  SetLength(w, K);
  for i := 0 to N - 1 do Read(f, a[i].len);
  for i := 0 to K - 1 do Read(f, w[i].x, w[i].y);
  CloseFile(f);

  x := 0; y := 0; dx := 1; dy := 0;
  for i := 0 to High(a) do begin
    a[i].x := x;
    a[i].y := y;
    Inc(x, dx * (a[i].len - 1));
    Inc(y, dy * (a[i].len - 1));
    a[i].dx := dx;
    a[i].dy := dy;
    t := dy;
    dy := -dx;
    dx := t;
  end;
  for j := 0 to High(w) do
    for i := 0 to High(a) do
      Draw(a[i], w[j], i = High(a));
  AssignFile(f, 'output.txt'); Rewrite(f);
  for i := 0 to High(w) do
    Write(f, w[i].count, ' ');
  CloseFile(f);
end.