{$apptype console}

// ACM 2007 1/4 final Far-East
// Problem E. Enormous spiral
// (C) Chistyakov T. S. 2007

uses
  Math, Classes;
  
type
  TLine = record
    a, b1, b2: integer;
    tag: integer;
  end;
  PLine = ^TLine;

var
  fi, fo: textfile;
  n, k, s: integer;
  a, x, y: array of integer;
  cnt: array of integer;

procedure addLine(l: TList; a, b1, b2: integer; tag: integer = 0);
var
  ln: PLine;
begin
  New(ln);
  ln^.a := a;
  ln^.b1 := Min(b1, b2);
  ln^.b2 := Max(b1, b2);
  ln^.tag := tag;
  l.Add(ln);
end;

function cmpLines(Item1, Item2: Pointer): Integer;
var
  l1: PLine absolute Item1;
  l2: PLine absolute Item2;
begin
  Result := l1^.a - l2^.a;
end;

procedure processDim(lines, squares: TList);
var
  i, j, minS, maxS: integer;
  a: integer;
  l, sq: PLine;
begin
  if lines.Count = 0 then
    Exit;

  minS := 0;
  maxS := 0;
  for i := 0 to lines.Count - 1 do begin
    l := PLine(lines[i]);
    a := l^.a;
    while minS < squares.Count do begin
      if PLine(squares[minS])^.a + s - 1 >= a then
        Break;
      Inc(minS);
    end;
    maxS := Max(0, maxS);
    while maxS < squares.Count do begin
      if PLine(squares[maxS])^.a > a then begin
        Dec(maxS);
        Break;
      end;
      Inc(maxS);
    end;
    maxS := Min(squares.Count - 1, maxS);

    for j := minS to maxS do begin
      sq := PLine(squares[j]);
      if (sq^.b1 <= l^.b2) and (l^.b1 <= sq^.b2) then
        Inc(cnt[sq^.tag], Abs(Max(l^.b1, sq^.b1) - Min(l^.b2, sq^.b2)) + 1);
    end;
  end;  
end;

var
  i, l: integer;
  xc, yc: integer;
  dx, dy: integer;
  xx, yy: TList;
  sqx, sqy: TList;
begin
  assignfile(fi, 'input.txt');
  reset(fi);
  assignfile(fo, 'output.txt');
  rewrite(fo);
  read(fi, n, k, s);
  setlength(a, n);
  for i := 0 to n - 1 do
    read(fi, a[i]);
  setlength(x, k);
  setlength(y, k);
  for i := 0 to k - 1 do
    read(fi, x[i], y[i]);
  xx := TList.Create;
  xx.Capacity := n div 2 + 1;
  yy := TList.Create;
  yy.Capacity := n div 2 + 1;
  xc := 0;
  yc := 0;
  dx := 1;
  dy := -1;
  for i := 0 to n - 1 do begin
    l := a[i] - 1;
    if i <> n - 1 then
      Dec(l);
    if i mod 2 = 0 then begin
      addLine(yy, yc, xc, xc + dx * l);
      Inc(xc, dx * (a[i] - 1));
      dx := -dx;
    end
    else begin
      addLine(xx, xc, yc, yc + dy * l);
      Inc(yc, dy * (a[i] - 1));
      dy := -dy;
    end;
  end;
  xx.Sort(cmpLines);
  yy.Sort(cmpLines);

  sqx := TList.Create;
  sqx.Capacity := k;
  sqy := TList.Create;
  sqy.Capacity := k;
  for i := 0 to k - 1 do begin
    addLine(sqx, x[i], y[i], y[i] - S + 1, i);
    addLine(sqy, y[i] - S + 1, x[i], x[i] + S - 1, i);
  end;
  sqx.Sort(cmpLines);
  sqy.Sort(cmpLines);

  SetLength(cnt, k);
  for i := 0 to k - 1 do
    cnt[i] := 0;

  processDim(xx, sqx);
  processDim(yy, sqy);

  for i := 0 to High(cnt) do
    write(fo, cnt[i], ' '); 
    
  closefile(fo);
  closefile(fi);
end.