
#include <fstream>
#include <vector>

const int dirx[4] = {1, 0, -1, 0};
const int diry[4] = {0, -1, 0, 1};

inline bool consumes (int l1, int r1, int u1, int d1, int l2, int r2, int u2, int d2)
{
  return (l1 <= l2) && (r2 <= r1) && (u1 >= u2) && (d2 >= d1);
}
inline bool notoverlap (int l1, int r1, int u1, int d1, int l2, int r2, int u2, int d2)
{
  return (r1 < l2) || (r2 < l1) || (d1 > u2) || (d2 > u1);
}

//#define nmax 1000
//#define kmax 1000

int main (int argc, char** argv)
{
  int cx0, cy0, cx1, cy1, n, k, s, lb, ub, upper, lower, count, j;
  std::vector<int> rs, ls, us, ds, hx, hy, x, y, a;
  //int ls[nmax], rs[nmax], us[nmax], ds[nmax], hx[nmax], hy[nmax], a[nmax], x[kmax], y[kmax];

  std::fstream input("input.txt", std::ios_base::in);
  std::fstream output("output.txt", std::ios_base::out);

  input >> n >> k >> s;

  rs.resize(n+1); ls.resize(n+1); us.resize(n+1); ds.resize(n+1);
  hx.resize(n+1); hy.resize(n+1); a.resize(n+1);
  x.resize(k); y.resize(k);

  for (int i = 0; i < n; ++i) input >> a[i];
  for (int i = 0; i < k; ++i) input >> x[i] >> y[i];

  cx0 = 0; cy0 = 0; cx1 = 0; cy1 = 0;
  rs[0] = 0; ls[0] = 0; us[0] = 0; ds[0] = 0; hx[0] = 0; hy[0] = 0;
  for (int i = 1; i <= n; ++i) 
  {
    cx0 = cx1; cy0 = cy1;
    cx1 = cx0 + dirx[(i - 1) % 4] * (a[i - 1] - 1); cy1 = cy0 + diry[(i - 1) % 4] * (a[i - 1] - 1);
    hx[i] = cx1; hy[i] = cy1;

    rs[i] = std::max(rs[i-1], std::max(cx0, cx1));
    ls[i] = std::min(ls[i-1], std::min(cx0, cx1));
    us[i] = std::max(us[i-1], std::max(cy0, cy1));
    ds[i] = std::min(ds[i-1], std::min(cy0, cy1));
  }

  for (int i = 0; i < k; ++i)
  {
    lb = 0; ub = n;
    while (ub - lb > 1)
    {
      int md = (ub + lb) / 2;
    
      if (consumes(ls[md], rs[md], us[md], ds[md], x[i], x[i] + s - 1, y[i], y[i] - s + 1))
        ub = md;
      else
        lb = md;
    }

    upper = std::min(ub + 5, n - 1);
    
    lb = 0; ub = n;
    while (ub - lb > 1)
    {
      int md = (ub + lb) / 2;
    
      if (notoverlap(ls[md], rs[md], us[md], ds[md], x[i], x[i] + s - 1, y[i], y[i] - s + 1))
        lb = md;
      else
        ub = md;
    }

    lower = std::max(0, lb - 5);

    //lower = 0; upper = n - 1;

    count = 0;
    for (j = lower; j <= upper; j++)
    {
      if (j % 2 == 0)
      {
        int minx = std::min(hx[j], hx[j+1]);
        int maxx = std::max(hx[j], hx[j+1]);
        if (y[i] - s + 1 <= hy[j] && hy[j] <= y[i]) count += std::max(0, std::min(x[i] + s - 1, maxx) - std::max(x[i], minx) + 1);
      }

      if (j % 2 == 1)
      {
        int miny = std::min(hy[j], hy[j+1]);
        int maxy = std::max(hy[j], hy[j+1]);
        if (x[i] <= hx[j] && hx[j] <= x[i] + s - 1) count += std::max(0, std::min(y[i], maxy) - std::max(y[i] - s + 1, miny) + 1);
      }

      if (x[i] <= hx[j+1] && hx[j+1] <= x[i] + s - 1 &&
          y[i] - s + 1 <= hy[j+1] && hy[j+1] <= y[i] && j+1 != n) count--;
    }
    output << count << " ";
  }
 
  return 0;
}
